package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.dao.DatasetDetailMapper;
import com.yice.webadmin.app.model.DatasetDetail;
import com.yice.webadmin.app.service.DatasetDetailService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 数据集详情数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("datasetDetailService")
public class DatasetDetailServiceImpl extends BaseService<DatasetDetail, Long> implements DatasetDetailService {

    @Autowired
    private DatasetDetailMapper datasetDetailMapper;
    @Autowired
    private IdGeneratorWrapper idGenerator;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<DatasetDetail> mapper() {
        return datasetDetailMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param datasetDetail 新增对象。
     * @return 返回新增对象。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public DatasetDetail saveNew(DatasetDetail datasetDetail) {
        datasetDetailMapper.insert(this.buildDefaultValue(datasetDetail));
        return datasetDetail;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param datasetDetailList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<DatasetDetail> datasetDetailList) {
        if (CollUtil.isNotEmpty(datasetDetailList)) {
            datasetDetailList.forEach(this::buildDefaultValue);
            datasetDetailMapper.insertList(datasetDetailList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<DatasetDetail> datasetDetailList, int batchSize) {
        if (CollUtil.isEmpty(datasetDetailList)) {
            return;
        }
        if (batchSize <= 0) {
            batchSize = 10000;
        }
        int start = 0;
        do {
            int end = Math.min(datasetDetailList.size(), start + batchSize);
            List<DatasetDetail> subList = datasetDetailList.subList(start, end);
            // TODO 如果数据量过大，同时当前表中存在createTime或updateTime等字段，可以考虑在外部创建一次 new Date()，
            // 然后传入buildDefaultValue，这样可以减少对象的创建次数，降低GC，提升效率。橙单之所以没有这样生成，是因为
            // 有些业务场景下需要按照这两个日期字段排序，因此我们只是在这里给出优化建议。
            subList.forEach(this::buildDefaultValue);
            datasetDetailMapper.insertList(subList);
            if (end == datasetDetailList.size()) {
                break;
            }
            start += batchSize;
        } while (true);
    }

    /**
     * 更新数据对象。
     *
     * @param datasetDetail         更新的对象。
     * @param originalDatasetDetail 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(DatasetDetail datasetDetail, DatasetDetail originalDatasetDetail) {
        MyModelUtil.fillCommonsForUpdate(datasetDetail, originalDatasetDetail);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<DatasetDetail> uw = this.createUpdateQueryForNullValue(datasetDetail, datasetDetail.getDetailId());
        return datasetDetailMapper.update(datasetDetail, uw) == 1;
    }

    /**
     * 删除指定数据。
     *
     * @param detailId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long detailId) {
        return datasetDetailMapper.deleteById(detailId) == 1;
    }

    /**
     * 当前服务的支持表为从表，根据主表的关联Id，删除一对多的从表数据。
     *
     * @param versionId 从表关联字段。
     * @return 删除数量。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public int removeByVersionId(Long versionId) {
        DatasetDetail deletedObject = new DatasetDetail();
        deletedObject.setVersionId(versionId);
        return datasetDetailMapper.delete(new QueryWrapper<>(deletedObject));
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getDatasetDetailListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<DatasetDetail> getDatasetDetailList(DatasetDetail filter, String orderBy) {
        return datasetDetailMapper.getDatasetDetailList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getDatasetDetailList)，以便获取更好的查询性能。
     *
     * @param filter  主表过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<DatasetDetail> getDatasetDetailListWithRelation(DatasetDetail filter, String orderBy) {
        List<DatasetDetail> resultList = datasetDetailMapper.getDatasetDetailList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    private DatasetDetail buildDefaultValue(DatasetDetail datasetDetail) {
        if (datasetDetail.getDetailId() == null) {
            datasetDetail.setDetailId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(datasetDetail);
        return datasetDetail;
    }
}
